%%%
%%% Esempio di modello discreto con disturbo
%%% per l'isolamento di guasti nei sensori
%%% d'ingresso
%%%

Tc   = 0.1;
Tsim = 50;

A = [0.9944 -0.1203 -0.4302;
     0.0017  0.9902 -0.0747;
     0       0.8187  0];

ts = 50;
 
 
E = [0 0 1]';


B = [1 0;
     0 1;
     0 0];

C = eye(3);
 
D = zeros(3,3); 
 
x0 = [0.01 0.02 0.03]; 

v = [0.75 0.80 0.85];


%%%
%%% Parametri del primo UIO, per
%%% l'isolamento del guasto sul primo
%%% ingresso: tale osservatore e'
%%% insensibile al primo ingresso.
%%% Basta osservare che valori assume
%%% la matrice J1 = T1*B...
%%%

E1 = [B(:,1) E];

H1 = E1*pinv(C*E1);

T1 = eye(size(H1*C)) - H1*C;

K11  = place( (A-H1*C*A)' , C', v )';

F1 = A-H1*C*A - K11*C;
 
K21  = F1*H1;

K1 = K11 + K21;

%dlsim(F,[T*B,K],eye(size(F)),[zeros(n,r) H],[U,Y]);

Auio1 = F1;
Buio1 = [T1*B K1];
Cuio1 = C;
Duio1 = [zeros(3,2) H1];

%%%
%%% Parametri del secondo UIO, per
%%% l'isolamento del guasto sul secondo
%%% ingresso: tale osservatore e'
%%% insensibile al secondo ingresso.
%%% Basta osservare che valori assume
%%% la matrice J2 = T2*B...
%%%

E2 = [B(:,2) E];

H2 = E2*pinv(C*E2);

T2 = eye(size(H2*C)) - H2*C;

K12  = place( (A-H2*C*A)' , C', v )';

F2 = A-H2*C*A - K12*C;
 
K22  = F2*H2;

K2 = K12 + K22;

%dlsim(F,[T*B,K],eye(size(F)),[zeros(n,r) H],[U,Y]);

Auio2 = F2;
Buio2 = [T2*B K2];
Cuio2 = C;
Duio2 = [zeros(3,2) H2];

return
